﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;


using DigitoalNL.VELReader;
using System.IO;

namespace EnergyLogReader
{
    public partial class frmLogReader : Form
    {
        public frmLogReader()
        {
            InitializeComponent();
        }

        VELReader logReader;
        private void openLogfileToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (logReader == null) logReader = new VELReader();

            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Multiselect = false;
            ofd.CheckFileExists = true;
            ofd.Filter = "Log files (*.bin)|*.bin|All files (*.*)|*.*";

            if (ofd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                logReader.Read(ofd.FileName);

                UpdateInfo();
                UpdateData();
            }
        }

        private void scanDirectoryToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (logReader == null) logReader = new VELReader();

            FolderBrowserDialog fbd = new FolderBrowserDialog();
            fbd.ShowNewFolderButton = false;

            if (fbd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                DirectoryInfo di = new DirectoryInfo(fbd.SelectedPath);

                foreach (FileInfo file in di.GetFiles())
                {
                    logReader.Read(file.FullName);
                }

                UpdateInfo();
                UpdateData();


            }

        }

        private void UpdateInfo() {
            lvInfo.Items.Clear();

            ListViewItem lviUID = new ListViewItem("UnitID");
            lviUID.SubItems.AddRange(new string[] { logReader.Info.UnitID.ToString(), "" });

            ListViewItem lviTPC = new ListViewItem("TotalPowerConsumed");
            lviTPC.SubItems.AddRange(new string[] { logReader.Info.TotalPowerConsumed.ToString(), "kWh" });            

            ListViewItem lviTRT = new ListViewItem("TotalRecordedTime");
            lviTRT.SubItems.AddRange(new string[] { logReader.Info.TotalRecoredTime.ToString(), "Hours" });

            ListViewItem lviTOT = new ListViewItem("TotalOnTime");
            lviTOT.SubItems.AddRange(new string[] { logReader.Info.TotalOnTime.ToString(), "Hours" });

            ListViewItem lviT1 = new ListViewItem("Tariff 1");
            lviT1.SubItems.AddRange(new string[] { logReader.Info.Tariff1.ToString(), "€/ct" });

            ListViewItem lviT2 = new ListViewItem("Tariff 2");
            lviT2.SubItems.AddRange(new string[] { logReader.Info.Tariff2.ToString(), "€/ct" });

            lvInfo.Items.AddRange(new ListViewItem[] { lviUID,lviTPC, lviTRT, lviTOT,lviT1,lviT2 });
        
        }
        private void UpdateData()
        {
            dgvData.DataSource = null;
            dgvData.DataSource = logReader.Log;
        }


    }
}
